#include <colysis.h>

#define RAYLIB_BACKEND

#include <alyson.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#include <raylib.h>

#include <raymath.h>
#include <rlyson.h>

#include <animation/sprite.h>


int main(int argc, char** argv)
{
    InitWindow(900, 600, "Colysis");

    SetConfigFlags(FLAG_WINDOW_RESIZABLE);
    Texture2D gery = LoadTexture(ASSETS_PATH "/karl-heinz_head.png");

    SpriteAnimation geryanim = CreateSpriteAnimation(gery, (Vector2){64*14,64}, (Vector2){64,64}, 0.f, 4.f, 5, 0.15f);

    Camera2D camera = { 0 };
    camera.target = (Vector2){0,0};
    camera.offset = (Vector2){GetScreenWidth()/2.f,GetScreenHeight()/2.f};
    camera.rotation = 0.f;
    camera.zoom = 1.f;

    while (!WindowShouldClose()) {
        ClearBackground((Color){ 0x00, 0x6d, 0xfb });
        float dt = GetFrameTime();



        UpdateSpriteAnimation(geryanim, dt);


        BeginDrawing();
        {
            BeginMode2D(camera);
            {
                DrawSpriteAnimation(geryanim, (Vector2){0,0});

            }
            EndMode2D();

            {
                DrawTextFull(GetFontDefault(), "Darling, I'm Home!", (Vector2){20,20}, TEXT_ORIENTATION_RIGHT, 0, 24, 5, 5, RAYWHITE);

            }
        }

        EndDrawing();
    }

    DestroySpriteAnimation(geryanim);
    UnloadTexture(gery);

    return 0;
}
